import 'variables.dart';
import 'package:geiger_localstorage/geiger_localstorage.dart';
import 'api.dart';
import 'dart:developer';
//import 'dummyAPI/creation.dart';
//import 'dummyAPI/metricreation.dart';

//Future init() async {
//  createLocal();
//  await createThreats();
//  await createPlugin();
//  await createProfiles();
//  await createRecommendations();
//  await createEnterprise();
//  await createEnterpriseDevices();
//  await createEnterpriseUsers();
//  await createUsers();
//  await createDevices();
//  await createMetricData();
//}

Future getUUID() async {

  Storage.userUUID = await Storage().getUUID('currentUser');
//  print('Indicator'+Storage.userUUID);

  Storage.deviceUUID = await Storage().getUUID('currentDevice');

//  print('Indicator'+Storage.deviceUUID);
}

Future clearPN() async{


  CoreValues.userPositive.clear();
  CoreValues.devicePositive.clear();
  CoreValues.userNegative.clear();
  CoreValues.deviceNegative.clear();

  log('indiA-clearPN ${CoreValues.userPositive.length},${CoreValues.devicePositive.length},${CoreValues.userNegative.length},${CoreValues.deviceNegative.length}');
}

Future initPlugin() async{
  try {
    var temp = await Storage().getPlugUUID();
    var tempIDs = [];
    tempIDs = temp.split(',');
    Storage.pluginUUIDs = tempIDs;
    await initPluginUser(tempIDs);
    await initPluginDevice(tempIDs);
  }
  catch (e){
    log('indiA-initPlugin ${e.toString()}');
  }

}

Future initPluginUser(var tempIDs) async{


  for (var pluginsUUID in tempIDs) {

      try {
          var path =':' + Types.users + ':' + Storage.userUUID + ':' + pluginsUUID +
              ':data:metrics';
          var metricNode = await Storage.controller!.get(path);
          var childrenNodes = await metricNode.getChildren();
          if(childrenNodes.isNotEmpty) Storage.getValuePath.add(path);

      } catch(e) {
            log('indiB-initPluginUser ${e.toString()}');
      }


    }

}

Future initPluginDevice(var tempIDs) async{

  for (var pluginsUUID in tempIDs) {
    try {
          var path = ':' + Types.devices + ':' + Storage.deviceUUID + ':' + pluginsUUID +
              ':data:metrics';
          var metricNode = await Storage.controller
      !.get( ':' + Types.devices + ':' + Storage.deviceUUID + ':' + pluginsUUID +
      ':data:metrics');
      var childrenNodes = await metricNode.getChildren();
      if(childrenNodes.isNotEmpty) Storage.getValuePath.add(path);
      } catch(e) {
        log('indiB-initPluginDevice ${e.toString()}');
      }


  }

}

Future checkExistNodes() async {

  await generateThreats();
  //await generateCoreValues();

  await getExistScoreNodes(Types.users, Types.geigerScoreUser);
  await getExistScoreNodes(Types.devices, Types.geigerScoreDevice);

  await getExistScoreNodes(Types.users, Types.recommendations);
  await getExistScoreNodes(Types.devices, Types.recommendations);

  await getExistScoreNodes(Types.users, Types.geigerScoreAggregate);
  await getExistScoreNodes(Types.enterprise,Types.geigerScoreMSE);
}

Future generateImplementedReco(var recos, var type) async{

  log('indiC generateImplementedReco');
   if(recos.toString().contains(',')){
     //log('indiC generateImplementedReco 1');
    var temp = recos.toString().split(',');
     //log('indiC generateImplementedReco 2');
      for(String implementedRecommendation in temp){
        //log('indiC generateImplementedReco 3');
        if(type == Types.users) {
          if (!CoreValues.uuidUserImplementedRecommendations.contains(implementedRecommendation)) {
                CoreValues.uuidUserImplementedRecommendations.add(implementedRecommendation);
                await getImplementedRecommendations(implementedRecommendation.toString().trim());
                log('indiA User getImplementedRecommendations $implementedRecommendation');
                //log('indiA update generateImplementedReco ${CoreValues.uuidUserImplementedRecommendations}');
          }
        }else{
          if (!CoreValues.uuidDeviceImplementedRecommendations.contains(implementedRecommendation)) {
            CoreValues.uuidDeviceImplementedRecommendations.add(implementedRecommendation);
            await getImplementedRecommendations(implementedRecommendation.toString().trim());
            log('indiA User getImplementedRecommendations $implementedRecommendation');
            //log('indiA update generateImplementedReco ${CoreValues.uuidDeviceImplementedRecommendations}');
          }
        }

      }
   }else{
     if(type == Types.users) {
       if (!CoreValues.uuidUserImplementedRecommendations.contains(recos.toString().trim())) {
         CoreValues.uuidUserImplementedRecommendations.add(recos.toString().trim());
         await getImplementedRecommendations(recos.toString().trim());
         log('indiA User getImplementedRecommendations $recos');
         //log('indiA update generateImplementedReco ${CoreValues.uuidUserImplementedRecommendations}');
       }
     }else{
       if (!CoreValues.uuidDeviceImplementedRecommendations.contains(
           recos.toString().trim())) {
         CoreValues.uuidDeviceImplementedRecommendations.add(recos.toString().trim());
         await getImplementedRecommendations(recos.toString().trim());
         log('indiA User getImplementedRecommendations $recos');
         //log('indiA update generateImplementedReco ${CoreValues.uuidDeviceImplementedRecommendations}');
       }
     }
   }

 // log('indiA User getImplementedRecommendations ${CoreValues.userImplementedRecommendation}');

}


Future generateCoreValues() async {
  try {
//    for (String uuidThreat in CoreValues.uuidThreats) {
//      var temp = <Node>[];
////      CoreValues.userPositive[uuidThreat] = temp;
////      temp = <Node>[];
////      CoreValues.userNegative[uuidThreat] = temp;
////      temp = <Node>[];
////      CoreValues.userRecommendation[uuidThreat] = temp;
////      temp = <Node>[];
////      CoreValues.devicePositive[uuidThreat] = temp;
////      temp = <Node>[];
////      CoreValues.deviceNegative[uuidThreat] = temp;
//      temp = <Node>[];
//      CoreValues.deviceRecommendation[uuidThreat] = temp;
//    }


  } catch (e) {
      // ignore: avoid_print
      print(e);
  }
}

Future generateThreats() async {
  try {
    var globalThreats = await Storage.controller!.get(':Global:threats');


    var nodesCsv = await globalThreats.getChildNodesCsv();
    var uuidThreats = nodesCsv.toString().split(',');
    //log('indiA uuidThreats ${uuidThreats.toString()}');
    var getChildren = await globalThreats.getChildren();
    var threatsIterator = getChildren.entries.iterator;
    var uuidIterator = uuidThreats.iterator;
    CoreValues.uuidThreats = uuidThreats;

    while (threatsIterator.moveNext()) {
      uuidIterator.moveNext();
      var nameNode = await threatsIterator.current.value.getValue('name');
      var name = nameNode!.getValue('en');
      var gnameNode = await threatsIterator.current.value.getValue('GEIGER_threat');
      var gname = gnameNode!.getValue('en');

      CoreValues.uuidName[uuidIterator.current] = name;
      CoreValues.nameUUID[name] = uuidIterator.current;

      CoreValues.uuidGname[uuidIterator.current] = gname;
      if(!CoreValues.gnameUUID.containsKey(gname)){
        CoreValues.gnameUUID[gname] = [];
        CoreValues.gnameUUID[gname].add(uuidIterator.current);
      }else{
        CoreValues.gnameUUID[gname].add(uuidIterator.current);
      }

    }

    //이름 같은 것 끼리 묶어야함 - 프로파일은 12개로 고정되어있음, 맵핑안되는 위협들은 점수를 못가짐

    //UUID -> NAME ->

    //기준 UUID를 찾고
    //기준 UUID의 NAME알고
    //기준 NAME과 같은 모든 Threat에 같은 값을 넣는다


  }catch(e) {
      log('indiA-generateThreats ${e.toString()}');
//      registerListener(Listener.threatGlobal,':Global:threats');
//
//      try{
//        List<Event> e = await Listener.threatGlobal.getNumEvents(1);
//        print("Length of the Event ${e.length}");
//        if (e.length > 0) {
//          generateThreats();
//        }
//      } catch(e){
//
//          print(e);
//      }
  }
}

Future normalization(Iterator<MapEntry<String, Node>> nodes) async {
  var minNode = await nodes.current.value.getValue('minValue');
  var valueNode = await nodes.current.value.getValue('GEIGERvalue');
  var maxNode = await nodes.current.value.getValue('maxValue');

  var minValue = double.parse(minNode!.getValue('en').toString());
  var value = double.parse(valueNode!.getValue('en').toString());

  return (value - minValue) /
      (double.parse(maxNode!.getValue('en').toString()) - minValue);
}

Future forUpdate(var node) async {

  try {
    var minNode = await node.getValue('minValue');
    var valueNode = await node.getValue('GEIGERvalue'); //GEIGERvalue
    var maxNode = await node.getValue('maxValue');
    var minValue = double.parse(minNode!.getValue('en').toString());
    var value = double.parse(valueNode!.getValue('en').toString());

    return (value - minValue) /
        (double.parse(maxNode!.getValue('en').toString()) - minValue);

  }catch(e){
    log('indiA forUpdate ${e.toString()}');
  }


}

Future crtThreatScore(var type) async {
  var positiveMetrics = 0.0;
  var negativeMetrics = 0.0;
  var implementedRecommendations = 0.0;
  var gspt = 0.0;
  var treatsScores = '';
 // var threatScoreValues = <dynamic>[];


  try {
    for (String threatUUID in CoreValues.uuidGthreats) {
       positiveMetrics = 0.0;
       negativeMetrics = 0.0;
       implementedRecommendations = 0.0;
       gspt = 0.0;

      if (type == Types.devices) {
        //log('indiC Types.devices');
        if (CoreValues.devicePositive.isNotEmpty &&
            CoreValues.devicePositive.containsKey(threatUUID)) positiveMetrics = await pnMetrics(CoreValues.devicePositive, threatUUID);
        if (CoreValues.deviceNegative.isNotEmpty &&
            CoreValues.deviceNegative.containsKey(threatUUID)) negativeMetrics = await pnMetrics(CoreValues.deviceNegative, threatUUID);
        if (CoreValues.deviceImplementedRecommendation.isNotEmpty &&
            CoreValues.deviceImplementedRecommendation.containsKey(threatUUID)) implementedRecommendations = await recoMetrics(CoreValues.deviceImplementedRecommendation, threatUUID);
      } else if (type == Types.users) {
        //log('indiC Types.users');
        //positiveMetrics = await pnMetrics(CoreValues.userPositive, threatUUID);
        //negativeMetrics = await pnMetrics(CoreValues.userNegative, threatUUID);
        if (CoreValues.userPositive.isNotEmpty && CoreValues.userPositive.containsKey(threatUUID)) {
         // log('indiC Types.users 1');
          positiveMetrics = await pnMetrics(CoreValues.userPositive, threatUUID);
        }else if (CoreValues.userNegative.isNotEmpty && CoreValues.userNegative.containsKey(threatUUID)) {
          //log('indiC Types.users 2');
          negativeMetrics = await pnMetrics(CoreValues.userNegative, threatUUID);
        }else if (CoreValues.userImplementedRecommendation.isNotEmpty && CoreValues.userImplementedRecommendation.containsKey(threatUUID)){
          implementedRecommendations = await recoMetrics(CoreValues.userImplementedRecommendation, threatUUID);
        }
      }
      log('indiC crtThreatScore $implementedRecommendations, $positiveMetrics, $negativeMetrics');
      gspt = 50 +
          (50 * negativeMetrics) -
          (25 * (positiveMetrics + implementedRecommendations));

      //log('indiC gspt $gspt');
      //    var threatValues = <dynamic, dynamic>{};
//
//    threatValues['threatId'] = threatUUID;
//    threatValues['name'] = CoreValues.uuidName[threatUUID].toString().trim();
//
//    var threat = <dynamic, dynamic>{};
//
//    threat['threat'] = threatValues;
//    threat['score'] = gspt;

//    threatScoreValues.add(threat);

      treatsScores += '$threatUUID,$gspt;';

      //log('indiC treatsScores $treatsScores');

      type == Types.devices
          ? CoreValues.deviceThreatScore[threatUUID] = gspt
          : CoreValues.userThreatScore[threatUUID] = gspt;


      //log('indiC deviceThreatScore ${CoreValues.deviceThreatScore[threatUUID] = gspt}');
      //log('indiC userThreatScore  ${CoreValues.userThreatScore[threatUUID] = gspt}');
    }


  }catch(e){
    log('indiA crtThreatScore ${e.toString()}');
  }



  return treatsScores;
}

Future crtTotalThreatScore(var type) async {
  var sumNumerator = 0.0;
  var sumDenominator = 0.0;
  var threatScore = {};

  type == Types.devices
      ? threatScore = CoreValues.deviceThreatScore
      : threatScore = CoreValues.userThreatScore;

  //log('indiC crtTotalThreatScore_deviceThreatScore ${CoreValues.deviceThreatScore}');
  //log('indiC crtTotalThreatScore_userThreatScore ${CoreValues.userThreatScore}');


  for (String threatUUID in CoreValues.uuidGthreats) {
    //here loop threat by threat
    var rpts = await riskMetrics(threatUUID);
    //log('indiC crtTotalThreatScore_rpts $rpts');
    for (var rpt in rpts) {
     // log('indiC crtTotalThreatScore_threatScore[threatUUID] $threatScore[threatUUID]');
      //log('indiC-crtTotalThreatScore_rpt $rpt');
      sumNumerator += threatScore[threatUUID] * rpt;
      sumDenominator += rpt;
    }
  }
  //log('indiC crtTotalThreatScore_sumNumerator $sumNumerator');
  //log('indiC crtTotalThreatScore_sumDenominator $sumDenominator');
  var gspUser = sumNumerator / sumDenominator;
  if(gspUser.isNaN) {
    log('indiA - crtTotalThreatScore - Check the relatedThreatsWeights');
    gspUser = 0.0;
  }

  Node scoreNums = NodeImpl(':sn', '');
  await scoreNums.addValue(NodeValueImpl('score', gspUser.toString()));
  await scoreNums.addValue(NodeValueImpl(
      'nums',
      (CoreValues.userPositive.length + CoreValues.userNegative.length)
          .toString()));
  CoreValues.aggregate.add(scoreNums);

  return gspUser.toString();
}

Future riskMetrics(var threatUUID) async {
  var uuid = await getEnterpriseUUID();
//  log('indiC riskMetrics_uuids $uuid');
//  log('indiC riskMetrics based ${CoreValues.based}');
//  log('indiC riskMetrics enabler ${CoreValues.enabler}');
//  log('indiC riskMetrics dependent ${CoreValues.dependent}');
  var result = 0.0;
  var results = [];

  //for (var uuid in uuids) {
    //log('indiC-riskMetrics uuid ${uuid.toString().trim()}');
    switch (uuid.toString().trim()) {
      case Types.digitallyBased:
        result = double.parse(CoreValues.based[threatUUID]);
        //log('indiC riskMetrics digitallyBased result $result');
        results.add(result);
        break;

      case Types.digitalEnabler:
        result = double.parse(CoreValues.enabler[threatUUID]);
        //log('indiC riskMetrics digitalEnabler result $result');
        results.add(result);
        break;

      case Types.digitallyDependent:
        result = double.parse(CoreValues.dependent[threatUUID]);
        //log('indiC riskMetrics digitallyDependent result $result');
        results.add(result);
        break;
    }
  //}

  return results;
}

Future pnMetrics(Map<String, List<dynamic>> node, var threatUUID) async {
  var impactV = 0.0;
  var numerator = 0.0;
  var denominator = 0.0;
  var normalization = 0.0;


  var metric;
  var temp = [];
      log('indiC pnMetrics ${node.keys}');

      if(node.containsKey(threatUUID)) {
        try {
          if (node[threatUUID].toString() == temp.toString()) {
            return 0.0;
          }


          metric = node[threatUUID]?.iterator;
        } catch (e) {
          //print('func224$e');
          log('indiA pnMetrics 1 ${e.toString()}');
          return 0.0;
        }

        try {
          while (metric.moveNext()) {
            var impact = await metric.current['impact'];
    //      var impact = impactNode.getValue('en');

            try {
              //log('indiC pnMetrics getValue ${await metric.current['normal']}');
              var normalNode = await metric.current['normal'];
              normalization = double.parse(normalNode);
            } catch (e) {
              log('indiA pnMetrics getValue ${e.toString()}');
              continue;
            }

            impactV = CoreValues.impactValues[impact.toLowerCase()]
          !;

          numerator += impactV * normalization; //numerator= impact*value
          denominator += impactV; //denom=impact
          }

          var result = numerator / denominator;

          return result;

          } catch (e) {
          log('indiA pnMetrics 2 ${e.toString()}');
          return 0.0;
          }

    }else{
      return 0.0;
    }
}

Future recoMetrics(var node, var threatUUID) async {
  var impactV = 0.0;
  var numerator = 0.0;
  var denominator = 0.0;
  var temp = [];

  try {

    log('indiC recoMetrics ${node.keys}');

    if(node.containsKey(threatUUID)) {
      if (node[threatUUID].toString() == temp.toString()) {
        return 0.0;
      }

      var metric = node[threatUUID]
      !.iterator;

      while (metric.moveNext()) {

          var impactNode = await metric.current.getValue('impact');
          var impact = impactNode.getValue('en');
          //log('indiC recoMetrics impact $impact');

          impactV = CoreValues.impactValues[impact.toLowerCase()]!;
          //log('indiC recoMetrics impact $impactV');
          //CoreValues.existReco.contains(threatUUID)

          numerator += impactV; //* node.length;
          denominator += impactV;
      }

      return numerator/denominator;

    }
  } catch (e) {
    log('indiA recoMetrics ${e.toString()}');
    return 0.0;
  }
}


Future crtGRecommendation(var type) async {
  var node = {};
  type == Types.devices
      ? node = CoreValues.deviceRecommendation
      : node = CoreValues.userRecommendation;
  var threatRecoList = [];
  var recUUID = '';


  //var recoObjVList = [];
  // var recoObjList = [];

  for (var m in CoreValues.gnameUUID.entries) {
    var recoLists = '';

    try {
          if(node.containsKey(m.key)) {
            var reco = node[m.key]!.iterator;

            while (reco.moveNext()) {
                var impactNode = await reco.current.getValue('impact');
                var impact = impactNode.getValue('en');

                try {
                var recuuidNode = await reco.current.getValue('recuuid');
                recUUID = recuuidNode.getValue('en');
                } catch (e) {
                continue;
                }
                var impactV = CoreValues.impactValues[impact.toLowerCase()]!;

                recoLists += '$recUUID,$impactV;';

                //type =="Devices" ? coreValues.deviceThreatScore[threatUUID] = Gspt : coreValues.userThreatScore[threatUUID] = Gspt;

//                var recoVal = {};
//                recoVal['weight'] = impactV;
//                recoVal['id'] = recUUID;
//                recoVal['type'] = type.toString().toLowerCase();
//                var shortNode = await reco.current.getValue('short');
//                recoVal['short'] = shortNode.getValue('en');
//                var longNode = await reco.current.getValue('long');
//                recoVal['long'] = longNode.getValue('en');
//
//                recoObjVList.add(recoVal);
            }
            if(recoLists.isNotEmpty) threatRecoList.add(NodeValueImpl(m.key, recoLists));

//            var threatVal = {};
//            threatVal['threatId'] = m.key;
//            threatVal['name'] = CoreValues.uuidName[m.key].toString().trim();
//
//            var recoObj = {};
//            recoObj['threat'] = threatVal;
//            recoObj['recommendations'] = recoObjVList;
//
//            var recoObjKey = {};
//            recoObjKey['recommendations'] = recoObj;
        }

  } catch (e) {
  continue;
  }
}

  return threatRecoList;
}


Future crtRecommendation(var type) async {
  var node = {};
  type == Types.devices
      ? node = CoreValues.deviceRecommendation
      : node = CoreValues.userRecommendation;
  var threatRecoList = [];
  var recUUID = '';
  var recoObjVList = [];
  // var recoObjList = [];
  //log('indiC crtRecommendation ${CoreValues.deviceRecommendation}');

  for (String threatUUID in CoreValues.uuidThreats) {
    var recoLists = '';

    try {
      var reco = node[threatUUID]!.iterator;

      while (reco.moveNext()) {
        var impactNode = await reco.current.getValue('impact');
        var impact = impactNode.getValue('en');

        try {
          var recuuidNode = await reco.current.getValue('recuuid');
          recUUID = recuuidNode.getValue('en');
        } catch (e) {
          continue;
        }
        var impactV = CoreValues.impactValues[impact.toLowerCase()]!;

        recoLists += '$recUUID,$impactV;';

        //type =="Devices" ? coreValues.deviceThreatScore[threatUUID] = Gspt : coreValues.userThreatScore[threatUUID] = Gspt;

        var recoVal = {};
        recoVal['weight'] = impactV;
        recoVal['id'] = recUUID;
        recoVal['type'] = type.toString().toLowerCase();
        var shortNode = await reco.current.getValue('short');
        recoVal['short'] = shortNode.getValue('en');
        var longNode = await reco.current.getValue('long');
        recoVal['long'] = longNode.getValue('en');

        recoObjVList.add(recoVal);
      }
      if(recoLists.isNotEmpty) threatRecoList.add(NodeValueImpl(threatUUID, recoLists));

      var threatVal = {};
      threatVal['threatId'] = threatUUID;
      threatVal['name'] = CoreValues.uuidName[threatUUID].toString().trim();

      var recoObj = {};
      recoObj['threat'] = threatVal;
      recoObj['recommendations'] = recoObjVList;

      var recoObjKey = {};
      recoObjKey['recommendations'] = recoObj;


    } catch (e) {
      continue;
    }
  }

  return threatRecoList;
}

Future crtAggregateScore() async {
  var sumNumerator = 0.0;
  var sumDenominator = 0.0;

  try {
        for (Node scoreNums in CoreValues.aggregate) {
          var scoreNode = await scoreNums.getValue('score');
          var gsp = double.parse(scoreNode!.getValue('en').toString());
      var numsNode = await scoreNums.getValue('score');
      var ns = double.parse(numsNode!.getValue('en').toString());
      sumNumerator += (gsp * ns);
      sumDenominator += ns;
      }
      CoreValues.gagg = sumNumerator / sumDenominator;
      CoreValues.nagg =sumDenominator;
  }catch(e)
  {
    log('indiA crtAggregateScore ${e.toString()}');
  }
}



Future registerListener(var l, var path, var type) async{
//  final localMaster =
//  (await getGeigerApi("", 'abc', Declaration.doShareData))
//  !;
//  var st = localMaster.getStorage();
  SearchCriteria s = SearchCriteria(searchPath: path);
  s.set(Field.type, type);
  Storage.controller!.registerChangeListener(l, s);
 // st!.registerChangeListener(l, s);
  //log('Listener======>$s');
  //print('Listener======>$s');

}

